
's = Dlg.FileOpenDlg("Choose File", "", "Text Files, txt, Log Files, log, HTML Files, htm html php asp hta")

Class Dialogs
Private Cls_Dlg, Cls_HTA, Cls_IE2

Public Function FileOpenDlg(Title, StartDir, sFilter) '-- openfiledlg([initFile as Variant][, initDir as Variant][, Filter as Variant][, Title as Variant])
    Dim Cls_Filter, Boo1, i2_c
       On Error Resume Next
     Boo1 = InitDlg()
        If Boo1 = False Then 
              CleanUp
              Boo1 = InitDlg()  '-- sometimes the first init fails. ?? Reason unknown.
        End If
     If Boo1 = False Then Err.Raise 1, "Dialogs Class", "Failed to initialize HtmlDlgHelper object": Exit Function
          
     If Len(sFilter) > 0 Then 
          Cls_Filter = GetFilterString(sFilter)
          FileOpenDlg = Cls_Dlg.openfiledlg(, CStr(StartDir), CStr(Cls_Filter), CStr(Title)) 
      Else
          FileOpenDlg = Cls_Dlg.openfiledlg(, CStr(StartDir), CStr("All Files(*.*)|*.*|"), CStr(Title)) 
      End If
      
       If Len(FileOpenDlg) = 0 Then Exit Function
    
        '--strange HTMLDlgHelper behavior. Returns a string ending with nulls.
        '-- The nulls won't affect using the string, but they will matter if you test the string.
        '-- For instance: If UCase(Right(s, 3)) = "TXT" Then ....   That won't work unless the nulls are snipped.
      For i2_c = 1 to Len(FileOpenDlg)
          If Asc(Mid(FileOpenDlg, i2_c, 1)) = 0 Then FileOpenDlg = Left(FileOpenDlg, (i2_c - 1)) : Exit For
      Next
     
      CleanUp
 End Function
   
Public Function ColorDlg()   '-- choosecolordlg([initColor as Variant])
 Dim Cls_LCol, Boo1
      
      On Error Resume Next
     Boo1 = InitDlg()
        If Boo1 = False Then 
              CleanUp
              Boo1 = InitDlg()
        End If
     If Boo1 = False Then Err.Raise 1, "Dialogs Class", "Failed to initialize HtmlDlgHelper object": Exit Function

    Cls_LCol = Cls_Dlg.choosecolordlg(0)
    ColorDlg = Hex(Cls_LCol)
    If Len(ColorDlg) < 6 Then ColorDlg = Right("000000" & ColorDlg, 6)
    ColorDlg = Right(ColorDlg, 2) & Mid(ColorDlg, 3, 2) & Left(ColorDlg, 2)
    CleanUp
End Function

Private Function GetFilterString(sFilter)
  Dim A1, i2, s1
   On Error Resume Next
     A1 = Split(sFilter, ",")
        i2 = 0
     Do While i2 < UBound(A1)
         GetFilterString = GetFilterString & Trim(A1(i2))
            s1 = Trim(A1(i2 + 1))
            s1 = "*." & s1
            s1 = Replace(s1, " ", ";*.")
            GetFilterString = GetFilterString & "(" & s1 & ")|" & s1 & "|" 
             i2 = i2 + 2
      Loop
End Function

Private Function InitDlg()
   Dim Cls_iCount, Cls_IE, Cls_SHAp
        '-- ugly hack required to get around problem of HTMLDlgHelper.HTMLDlgHelper being a control that needs to be sited.
     '-- it's also not marked as safe for scripting. This method dynamically creates an HTA, then gets the window.
     InitDlg = False
   CreateObject("WSCript.Shell").Run "MSHTA.EXE ""javascript:new ActiveXObject('InternetExplorer.Application').PutProperty('ID1', window);""", 0, False 

     '-- Next step: go through open windows and retrieve the window object for just-created HTA.
    Set Cls_SHAp = CreateObject("Shell.Application") 
    On Error Resume Next  
     Cls_iCount = 1
          Do Until Cls_iCount = 10
             For Each Cls_IE In Cls_SHAp.Windows
                If IsObject(Cls_IE.GetProperty("ID1")) Then
                    Set Cls_IE2 = Cls_IE           
                    Exit Do
                End If   
             Next 
                WScript.sleep 100
                Cls_iCount = Cls_iCount + 1
          Loop  
      Set Cls_SHAp = Nothing '-- done with Shell.Application. 
      If Not IsObject(Cls_IE2) Then Exit Function
 
      Set Cls_HTA = Cls_IE2.GetProperty("ID1")  '-- Cls_HTA is now an HTMLWindow2 object.
          '-- instantiate the HTMLDlgHelper.HTMLDlgHelper control.
      Cls_HTA.document.body.innerHTML = "<OBJECT ID=Dlg CLASSID=CLSID:3050F4E1-98B5-11CF-BB82-00AA00BDCE0B> </object>"
      Set Cls_Dlg = Cls_HTA.Dlg.Object  '-- get a reference to the control.
      Cls_IE2.quit  '-- this seems to be necessary, but if done elsewhere it may cause an odd lag of 4-5 seconds.

   If IsObject(Cls_Dlg) Then InitDlg = True
End Function

Private Sub CleanUp()
  On Error Resume Next
    Set Cls_Dlg = Nothing 
   If IsObject(Cls_HTA) Then
      Cls_HTA.Close 
      Set Cls_HTA = Nothing
   End If   
   If IsObject(Cls_IE2) Then
      Cls_IE2.quit
      Set Cls_IE2 = Nothing
    End If
End Sub

  '-- this shouldn't be necessary because each HTA is closed after a call is made.
Private Sub Class_Terminate()
   CleanUp
End Sub

End Class

Class ClsBrowseForFolder
 Private ShAp
          
 Private Sub Class_Initialize()
     On Error Resume Next
       Set ShAp = CreateObject("Shell.Application")
 End Sub

 Private Sub Class_Terminate()
        Set ShAp = Nothing
 End Sub

'------------------- ChooseFolder Function --------------------------------------
'-- this is a version that does Not show files and will Not return Namespaces. ------------
Public Function ChooseFolder(sCaption)
 Dim Fol, sFolName, sParentName, FolParent, Pt, Pt1, PtColon
  On Error Resume Next
    
    Set Fol = ShAp.BrowseForFolder(0, sCaption, 0)
      Err.clear
     sFolName = Fol.Title
       If (Err.number <> 0) Then  '--cancel was clicked so Fol is Not an object.
           ChooseFolder = ""
           Exit Function
       End If
    
      sParentName = "a"             
  Do While sParentName <> ""
      Set FolParent = Fol.parentfolder
       sParentName = FolParent.title          
                  '--  an error here means no parent folder and no : has been found below
                  '--  so it must be a drive or namespace (control panel, etc.)          
         If (Err.number <> 0) Then 
            Pt1 = instr(sFolName, ":") 
                If (Pt1 = 0) Then                   '--it's a namespace or namespace path. check For Desktop.
                    If (Left(sFolName, 6) = "Deskto") Then
                        FixPath sFolName
                        ChooseFolder = DeWeb(sFolName)
                    Else
                        ChooseFolder = ""
                    End If
                       Set Fol = Nothing
                       Set FolParent = Nothing   
                       Exit Function
                Else                                '--it's a drive. extract root folder path (ex.: C:\ )
                   sParentName =  mid(sFolName, (Pt1 - 1), 2)
                   ChooseFolder = sParentName & "\"
                   Set Fol = Nothing
                   Set FolParent = Nothing
                   Exit Function
               End If
         End If
       
         If (Len(sParentName) > 0) Then   '--look For a colon. If found Then quit Loop. If Not Then keep going.
             PtColon = instr(sParentName, ":")
                If (PtColon = 0) Then         '-- no colon. add folder name to path and keep going.
                     sFolName = sParentName & ("\" & sFolName)
                Else                      '--colon found. Get root folder, add to path and quit Loop.
                    sParentName = mid(sParentName, (PtColon - 1), 2)
                    sFolName = sParentName & ("\" & sFolName)
                    Exit Do
                End If
         End If
            
      '-- If it's still going Then the End of the path hasn't been found.
      '-- Set the parent folder as Fol object and redo the Loop:
         Set Fol = FolParent
    Loop  
       Set Fol = Nothing
       Set FolParent = Nothing
       ChooseFolder = DeWeb(sFolName)
End Function

'-- remove %20 just in Case.
Private Function DeWeb(sFol)
 DeWeb = Replace(sFol, "%20", " ")
End Function


'--fix path when returned with desktop namespace. Any folders on Desktop
'-- will be returned as:  Desktop\folderpath

Private Sub FixPath(sPath) 
  Dim sDesk, SHL
     On Error Resume Next
      Set SHL = CreateObject("WScript.Shell")
        sDesk = SHL.Specialfolders("Desktop")
     Set SHL = Nothing  
     
   If (Len(sPath) = 7) Then
      sPath = sDesk
   Else
     sPath = Right(sPath, (Len(sPath) - 7))
     sPath = sDesk & sPath
   End If  
End Sub

End Class